# -*- coding: utf-8 -*-
"""
Created on Thu Feb 15 15:33:25 2024

@author: ariccardi
"""
# For linear algebra
import numpy as np
# For random numbers
import random as rn
# For results reproducibility
rn.seed(0)

def random_network_generator(number_of_states, number_of_inputs, number_of_elements_per_column):
    
    # Initialize empty matrices
    A = np.full((number_of_states,number_of_states), 0, dtype='float64')
    B = np.full((number_of_states,number_of_inputs), 0, dtype='float64')


    # Creation of matrix A
    for i in range(0,number_of_states):

        for j in range(0,number_of_states):
            
            # Assignes an element (i,j) with a certain probability
            random_number = rn.random()
            if random_number >= 0.9:
                A[i,j] = rn.random()

            
    # Creation of matrix B            
    for j in range(0,number_of_inputs):
         
        # Defines how many elements has a column of B
        # number_of_elemnts_per_column = 1
        # number_of_elemnts_per_column = rn.randint(0, number_of_states-1)
        
        for i in range(0, number_of_elements_per_column):
            # Assigns a random element to a random place a random number of times
            raw_index = rn.randint(0, number_of_states-1)
            B[raw_index,j] = rn.random()
            
    return A, B