# Support functions
from A00_Support_Funcitons import *

def weighting_function(Network_Dict, List_Atomic_Agents, Partition, ALPHA):

    A = Network_Dict['A']
    B = Network_Dict['B']
    Weighted_Adjacency_Matrix = Network_Dict['Weighted_Adjacency_Matrix']
    NUMBER_OF_ATOMIC_AGENTS = Network_Dict['NUMBER_OF_ATOMIC_AGENTS']
    # List_Atomic_Agents = Network_Dict['List_Atomic_Agents']

    # W_Inter_List = create_empty_list(NUMBER_OF_ATOMIC_AGENTS)
    # W_Intra_List = create_empty_list(NUMBER_OF_ATOMIC_AGENTS)
    # W_Size_List = create_empty_list(NUMBER_OF_ATOMIC_AGENTS)
    W_Inter_List = np.zeros((NUMBER_OF_ATOMIC_AGENTS))
    W_Intra_List = np.zeros((NUMBER_OF_ATOMIC_AGENTS))
    W_Size_List = np.zeros((NUMBER_OF_ATOMIC_AGENTS))
    W_Inter = 0
    W_Intra = 0
    W_Size = 0

    for idx in range(NUMBER_OF_ATOMIC_AGENTS):
        # Size cost
        W_Size_List[idx] = pow(len(Partition[idx]),2)
        # W_Size_List[idx] = pow(len(Partition[idx]),1)

        # Intra-agent cost
        W_Intra_List[idx] = 0
        for i in range(len(Partition[idx])):
            agent_i = Partition[idx][i]
            for j in range(len(Partition[idx])):
                agent_j = Partition[idx][j]
                if i != j:
                    W_Intra_List[idx] = W_Intra_List[idx] + Weighted_Adjacency_Matrix[agent_i,agent_j]
                    # W_Intra_List[idx] = pow(W_Intra_List[idx],2) + pow(Weighted_Adjacency_Matrix[agent_i,agent_j],2)

        # Inter-agent cost
        W_Inter_List[idx] = 0
        for i in range(len(Partition[idx])):
            agent_i = Partition[idx][i]
            for j in range(NUMBER_OF_ATOMIC_AGENTS):
                agent_j = List_Atomic_Agents[j]
                if agent_j not in Partition[idx]:
                    W_Inter_List[idx] = W_Inter_List[idx] + Weighted_Adjacency_Matrix[agent_i,agent_j]
                    # W_Inter_List[idx] = pow(W_Inter_List[idx],2) + pow(Weighted_Adjacency_Matrix[agent_i,agent_j],2)

        # Individual costs
        W_Size = W_Size + W_Size_List[idx]
        W_Intra = W_Intra + W_Intra_List[idx]
        W_Inter = W_Inter + W_Inter_List[idx]
        
    #  Cost of the Partition
    # W_Partition = W_Intra - W_Inter - ALPHA*W_Size
    # W_Partition = W_Intra - W_Inter - 1/(ALPHA*W_Size)
    # W_Partition = W_Intra/(ALPHA*W_Size) - W_Inter/(ALPHA*W_Size)
    # W_Partition = W_Intra/W_Inter
    # W_Partition = W_Intra/(W_Inter + ALPHA*W_Size)
    #################################################################################
    # WORKING BUT NOT SUBMODULAR
    # W_Partition = W_Intra/(1 + W_Inter) - ALPHA*W_Size # Giving modules of four
    ################################################################################
    # SUBMODULAR BUT NOT GRAT WITH Modular_64
    # W_Partition = W_Intra/(1 + W_Inter) + ALPHA/(1+W_Size)
    # EPSILON = 1e-10
    # W_Partition = W_Intra/(EPSILON + W_Inter) + ALPHA/(EPSILON+W_Size)
    # W_Partition = W_Intra/(1 + W_Inter) + ALPHA/(1+W_Size)
    # W_Partition = W_Intra/(1 + W_Inter + ALPHA*W_Size)
    # W_Partition = W_Intra/W_Inter - ALPHA*W_Size/(1 + W_Intra)
    # W_Partition = W_Intra/W_Inter + ALPHA/W_Size
    
    ################################################# WORKING

    W_Partition = W_Intra/(1 + W_Inter) + ALPHA/(1 + W_Size)

    ################################################## TEST NEW METRIC

    # W_Partition = W_Intra/(1 + W_Inter) + 1/(1 + ALPHA*W_Size)

    # W_Partition = 0
    # for idx in range(NUMBER_OF_ATOMIC_AGENTS):
    #     W_Partition = W_Partition + ((W_Intra_List[idx]/W_Intra)/(W_Inter_List[idx]/W_Inter)) + ALPHA*(W_Size/W_Size_List[idx])

    return W_Partition

def weighting_function_detailed(Network_Dict, List_Atomic_Agents, Partition, ALPHA, NUMBER_CONTROL_AGENTS):

    A = Network_Dict['A']
    B = Network_Dict['B']
    Weighted_Adjacency_Matrix = Network_Dict['Weighted_Adjacency_Matrix']
    NUMBER_OF_ATOMIC_AGENTS = Network_Dict['NUMBER_OF_ATOMIC_AGENTS']
    # List_Atomic_Agents = Network_Dict['List_Atomic_Agents']

    # W_Inter_List = create_empty_list(NUMBER_OF_ATOMIC_AGENTS)
    # W_Intra_List = create_empty_list(NUMBER_OF_ATOMIC_AGENTS)
    # W_Size_List = create_empty_list(NUMBER_OF_ATOMIC_AGENTS)
    W_Inter_List = np.zeros((NUMBER_OF_ATOMIC_AGENTS))
    W_Intra_List = np.zeros((NUMBER_OF_ATOMIC_AGENTS))
    W_Size_List = np.zeros((NUMBER_OF_ATOMIC_AGENTS))
    W_Inter = 0
    W_Intra = 0
    W_Size = 0

    for idx in range(NUMBER_CONTROL_AGENTS):
        # Size cost
        W_Size_List[idx] = pow(len(Partition[idx]),2)
        # W_Size_List[idx] = pow(len(Partition[idx]),1)

        # Intra-agent cost
        W_Intra_List[idx] = 0
        for i in range(len(Partition[idx])):
            agent_i = Partition[idx][i]
            for j in range(len(Partition[idx])):
                agent_j = Partition[idx][j]
                if i != j:
                    W_Intra_List[idx] = W_Intra_List[idx] + Weighted_Adjacency_Matrix[agent_i,agent_j]
                    # W_Intra_List[idx] = pow(W_Intra_List[idx],2) + pow(Weighted_Adjacency_Matrix[agent_i,agent_j],2)

        # Inter-agent cost
        W_Inter_List[idx] = 0
        for i in range(len(Partition[idx])):
            agent_i = Partition[idx][i]
            for j in range(NUMBER_OF_ATOMIC_AGENTS):
                agent_j = List_Atomic_Agents[j]
                if agent_j not in Partition[idx]:
                    W_Inter_List[idx] = W_Inter_List[idx] + Weighted_Adjacency_Matrix[agent_i,agent_j]
                    # W_Inter_List[idx] = pow(W_Inter_List[idx],2) + pow(Weighted_Adjacency_Matrix[agent_i,agent_j],2)

        # Individual costs
        W_Size = W_Size + W_Size_List[idx]
        W_Intra = W_Intra + W_Intra_List[idx]
        W_Inter = W_Inter + W_Inter_List[idx]
        
    #  Cost of the Partition
    # W_Partition = W_Intra - W_Inter - ALPHA*W_Size
    # W_Partition = W_Intra - W_Inter - 1/(ALPHA*W_Size)
    # W_Partition = W_Intra/(ALPHA*W_Size) - W_Inter/(ALPHA*W_Size)
    # W_Partition = W_Intra/W_Inter
    # W_Partition = W_Intra/(W_Inter + ALPHA*W_Size)
    #################################################################################
    # WORKING BUT NOT SUBMODULAR
    # W_Partition = W_Intra/(1 + W_Inter) - ALPHA*W_Size # Giving modules of four
    ################################################################################
    # SUBMODULAR BUT NOT GRAT WITH Modular_64
    # W_Partition = W_Intra/(1 + W_Inter) + ALPHA/(1+W_Size)
    # EPSILON = 1e-10
    # W_Partition = W_Intra/(EPSILON + W_Inter) + ALPHA/(EPSILON+W_Size)
    # W_Partition = W_Intra/(1 + W_Inter) + ALPHA/(1+W_Size)
    # W_Partition = W_Intra/(1 + W_Inter + ALPHA*W_Size)
    # W_Partition = W_Intra/W_Inter - ALPHA*W_Size/(1 + W_Intra)
    # W_Partition = W_Intra/W_Inter + ALPHA/W_Size
    
    ################################################# WORKING

    W_Partition = W_Intra/(1 + W_Inter) + ALPHA/(1 + W_Size)

    ################################################## TEST NEW METRIC

    # W_Partition = W_Intra/(1 + W_Inter) + 1/(1 + ALPHA*W_Size)

    # W_Partition = 0
    # for idx in range(NUMBER_OF_ATOMIC_AGENTS):
    #     W_Partition = W_Partition + ((W_Intra_List[idx]/W_Intra)/(W_Inter_List[idx]/W_Inter)) + ALPHA*(W_Size/W_Size_List[idx])

    return W_Partition, W_Intra, W_Inter, W_Size